summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author Matteo Bernardini <ponce@slackbuilds.org>2012-11-20 11:37:38 +0100
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2016-01-17 09:40:16 +0700
commit6ff9ab871cbe8a8090be0b9d0ed06bcf6fc13a43 (patch)
treeaa02312c8b57c9a9ac9fa64ed6dfc0ab4ab6bc98
parent80182e069db1625d41f42d5211592949a31d1fc6 (diff)
downloadslackbuilds-6ff9ab871cbe8a8090be0b9d0ed06bcf6fc13a43.tar.gz
slackbuilds-6ff9ab871cbe8a8090be0b9d0ed06bcf6fc13a43.tar.xz
system/spice-vdagent: Added (spice agent for Linux vms).
Signed-off-by: Matteo Bernardini <ponce@slackbuilds.org>
-rw-r--r--system/spice-vdagent/README8
-rw-r--r--system/spice-vdagent/doinst.sh37
-rw-r--r--system/spice-vdagent/files/06-spice-vdagent.conf37
-rw-r--r--system/spice-vdagent/files/rc.spice-vdagent64
-rw-r--r--system/spice-vdagent/slack-desc19
-rw-r--r--system/spice-vdagent/spice-vdagent.SlackBuild104
-rw-r--r--system/spice-vdagent/spice-vdagent.info10
7 files changed, 279 insertions, 0 deletions
diff --git a/system/spice-vdagent/README b/system/spice-vdagent/README
new file mode 100644
index 0000000000..07292e9f81
--- /dev/null
+++ b/system/spice-vdagent/README
@@ -0,0 +1,8 @@
+spice-vdagent (spice agent for Linux vms)
+
+spice-vdagent enhanches interactions with your Linux virtual guests:
+- client mouse mode
+- automatic adjustment of the X-session resolution to the client's one
+- support of copy and paste
+- limited support for multiple displays using Xinerama
+- full support for multiple displays using Xrandr
diff --git a/system/spice-vdagent/doinst.sh b/system/spice-vdagent/doinst.sh
new file mode 100644
index 0000000000..97bb4e39c5
--- /dev/null
+++ b/system/spice-vdagent/doinst.sh
@@ -0,0 +1,37 @@
+config() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ # If there's no config file by that name, mv it over:
+ if [ ! -r $OLD ]; then
+ mv $NEW $OLD
+ elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
+ # toss the redundant copy
+ rm $NEW
+ fi
+ # Otherwise, we leave the .new copy for the admin to consider...
+}
+
+preserve_perms() {
+ NEW="$1"
+ OLD="$(dirname $NEW)/$(basename $NEW .new)"
+ if [ -e $OLD ]; then
+ cp -a $OLD ${NEW}.incoming
+ cat $NEW > ${NEW}.incoming
+ mv ${NEW}.incoming $NEW
+ fi
+ config $NEW
+}
+
+preserve_perms etc/rc.d/rc.spice-vdagent.new
+config usr/share/X11/xorg.conf.d/06-spice-vdagent.conf.new
+
+# If not already there, start the daemon from /etc/rc.d/rc.local
+if [ ! "$(grep rc\.spice-vdagent etc/rc.d/rc.local)" ]; then
+ cat << EOF >> etc/rc.d/rc.local
+
+# Start spice-vdagent:
+if [ -x /etc/rc.d/rc.spice-vdagent ]; then
+ /etc/rc.d/rc.spice-vdagent start
+fi
+EOF
+fi
diff --git a/system/spice-vdagent/files/06-spice-vdagent.conf b/system/spice-vdagent/files/06-spice-vdagent.conf
new file mode 100644
index 0000000000..f74be0db09
--- /dev/null
+++ b/system/spice-vdagent/files/06-spice-vdagent.conf
@@ -0,0 +1,37 @@
+Section "ServerLayout"
+ Identifier "Default Layout"
+ Screen 0 "Screen0" 0 0
+ InputDevice "Keyboard0" "CoreKeyboard"
+ InputDevice "Mouse" "CorePointer"
+ InputDevice "Tablet" "SendCoreEvents"
+EndSection
+
+Section "InputDevice"
+ Identifier "Keyboard0"
+ Driver "kbd"
+ Option "XkbModel" "pc105"
+ Option "XkbLayout" "us"
+EndSection
+
+Section "InputDevice"
+ Identifier "Mouse"
+ Driver "mouse"
+ Option "Device" "/dev/input/mice"
+ #Option "Emulate3Buttons" "yes"
+EndSection
+
+Section "InputDevice"
+ Identifier "Tablet"
+ Driver "evdev"
+ Option "Device" "/dev/input/event3"
+EndSection
+
+Section "Screen"
+ Identifier "Screen0"
+ Device "XSPICE"
+ DefaultDepth 24
+ SubSection "Display"
+ Viewport 0 0
+ Depth 24
+ EndSubSection
+EndSection
diff --git a/system/spice-vdagent/files/rc.spice-vdagent b/system/spice-vdagent/files/rc.spice-vdagent
new file mode 100644
index 0000000000..9c3ff19cc8
--- /dev/null
+++ b/system/spice-vdagent/files/rc.spice-vdagent
@@ -0,0 +1,64 @@
+#!/bin/sh
+#
+# spice-vdagentd Agent daemon for Spice guests
+#
+# Red Hat specific script slightly adapted for the Slackware init system
+# by Matteo Bernardini <ponce@slackbuilds.org>
+#
+# Description: Together with a per X-session agent process the spice agent
+# daemon enhances the spice guest user experience with client
+# mouse mode, guest <-> client copy and paste support and more.
+
+exec="/usr/sbin/spice-vdagentd"
+prog="spice-vdagentd"
+port="/dev/virtio-ports/com.redhat.spice.0"
+pid="/var/run/spice-vdagentd/spice-vdagentd.pid"
+
+lockfile=/var/lock/subsys/$prog
+
+start() {
+ /sbin/modprobe uinput > /dev/null 2>&1
+ # In case the previous running vdagentd crashed
+ /usr/bin/rm -f /var/run/spice-vdagentd/spice-vdagent-sock
+ /usr/bin/echo "Starting $prog: "
+ $exec -s $port
+ retval=$?
+ /usr/bin/echo
+ [ $retval -eq 0 ] && echo "$(pidof $prog)" > $pid && /usr/bin/touch $lockfile
+ return $retval
+}
+
+stop() {
+ if [ "$(pidof $prog)" ]; then
+ /usr/bin/echo "Stopping $prog: "
+ /bin/kill $pid
+ else
+ /usr/bin/echo "$prog not running"
+ return 1
+ fi
+ retval=$?
+ /usr/bin/echo
+ [ $retval -eq 0 ] && rm -f $lockfile $pid
+ return $retval
+}
+
+restart() {
+ stop
+ start
+}
+
+case "$1" in
+ start)
+ $1
+ ;;
+ stop)
+ $1
+ ;;
+ restart)
+ $1
+ ;;
+ *)
+ /usr/bin/echo $"Usage: $0 {start|stop|restart}"
+ exit 2
+esac
+exit $?
diff --git a/system/spice-vdagent/slack-desc b/system/spice-vdagent/slack-desc
new file mode 100644
index 0000000000..f058ca3eb1
--- /dev/null
+++ b/system/spice-vdagent/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+spice-vdagent: spice-vdagent (spice agent for Linux vms)
+spice-vdagent:
+spice-vdagent: spice-vdagent enhanches interactions with your Linux virtual guests:
+spice-vdagent: - client mouse mode
+spice-vdagent: - automatic adjustment of the X-session resolution to the client's one
+spice-vdagent: - support of copy and paste
+spice-vdagent: - limited support for multiple displays using Xinerama
+spice-vdagent: - full support for multiple displays using Xrandr
+spice-vdagent:
+spice-vdagent: homepage: http://spice-space.org
+spice-vdagent:
diff --git a/system/spice-vdagent/spice-vdagent.SlackBuild b/system/spice-vdagent/spice-vdagent.SlackBuild
new file mode 100644
index 0000000000..0db5a0472e
--- /dev/null
+++ b/system/spice-vdagent/spice-vdagent.SlackBuild
@@ -0,0 +1,104 @@
+#!/bin/sh
+
+# Slackware build script for spice-vdagent
+# Copyright Matteo Bernardini <ponce@slackbuilds.org>, 2012
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+PRGNAM=spice-vdagent
+VERSION=${VERSION:-0.12.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i486 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+DOCS="COPYING ChangeLog README TODO"
+
+set -e # Exit on most errors
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $PRGNAM-$VERSION
+tar xvf $CWD/$PRGNAM-$VERSION.tar.?z*
+cd $PRGNAM-$VERSION
+chown -R root:root .
+find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
+
+CFLAGS="$SLKCFLAGS" \
+CXXFLAGS="$SLKCFLAGS" \
+./configure \
+ --prefix=/usr \
+ --libdir=/usr/lib${LIBDIRSUFFIX} \
+ --sysconfdir=/etc \
+ --localstatedir=/var \
+ --docdir=/usr/doc/$PRGNAM-$VERSION \
+ --build=$ARCH-slackware-linux
+
+make
+make install DESTDIR=$PKG
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+# Install an init script and an X.org configuration file
+install -m 0755 -D $CWD/files/rc.spice-vdagent \
+ $PKG/etc/rc.d/rc.spice-vdagent.new
+install -m 0644 -D $CWD/files/06-spice-vdagent.conf \
+ $PKG/usr/share/X11/xorg.conf.d/06-spice-vdagent.conf.new
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a $DOCS $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+cat $CWD/doinst.sh > $PKG/install/doinst.sh
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.${PKGTYPE:-tgz}
diff --git a/system/spice-vdagent/spice-vdagent.info b/system/spice-vdagent/spice-vdagent.info
new file mode 100644
index 0000000000..10de6d1b70
--- /dev/null
+++ b/system/spice-vdagent/spice-vdagent.info
@@ -0,0 +1,10 @@
+PRGNAM="spice-vdagent"
+VERSION="0.12.0"
+HOMEPAGE="http://spice-space.org"
+DOWNLOAD="http://spice-space.org/download/releases/spice-vdagent-0.12.0.tar.bz2"
+MD5SUM="a7de4d6682099b7af9c289ef3e2996f7"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="spice xf86-video-qxl"
+MAINTAINER="Matteo Bernardini"
+EMAIL="ponce@slackbuilds.org"